# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AclTemplateDeviceDetail',
    'AclTemplateInboundRule',
    'DeviceClusterDetails',
    'DeviceClusterDetailsNode0',
    'DeviceClusterDetailsNode0VendorConfiguration',
    'DeviceClusterDetailsNode1',
    'DeviceClusterDetailsNode1VendorConfiguration',
    'DeviceInterface',
    'DeviceLinkDevice',
    'DeviceLinkLink',
    'DeviceLinkMetroLink',
    'DeviceSecondaryDevice',
    'DeviceSecondaryDeviceInterface',
    'DeviceSecondaryDeviceSshKey',
    'DeviceSshKey',
    'GetDeviceClusterDetailResult',
    'GetDeviceClusterDetailNode0Result',
    'GetDeviceClusterDetailNode0VendorConfigurationResult',
    'GetDeviceClusterDetailNode1Result',
    'GetDeviceClusterDetailNode1VendorConfigurationResult',
    'GetDeviceInterfaceResult',
    'GetDeviceSecondaryDeviceResult',
    'GetDeviceSecondaryDeviceInterfaceResult',
    'GetDeviceSecondaryDeviceSshKeyResult',
    'GetDeviceSshKeyResult',
]

@pulumi.output_type
class AclTemplateDeviceDetail(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "aclStatus":
            suggest = "acl_status"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclTemplateDeviceDetail. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclTemplateDeviceDetail.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclTemplateDeviceDetail.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 acl_status: Optional[str] = None,
                 name: Optional[str] = None,
                 uuid: Optional[str] = None):
        """
        :param str acl_status: Device ACL provisioning status where template was applied. One of `PROVISIONING`, `PROVISIONED`.
        :param str name: ACL template name.
        :param str uuid: Device uuid.
        """
        if acl_status is not None:
            pulumi.set(__self__, "acl_status", acl_status)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter(name="aclStatus")
    def acl_status(self) -> Optional[str]:
        """
        Device ACL provisioning status where template was applied. One of `PROVISIONING`, `PROVISIONED`.
        """
        return pulumi.get(self, "acl_status")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        ACL template name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def uuid(self) -> Optional[str]:
        """
        Device uuid.
        """
        return pulumi.get(self, "uuid")


@pulumi.output_type
class AclTemplateInboundRule(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dstPort":
            suggest = "dst_port"
        elif key == "srcPort":
            suggest = "src_port"
        elif key == "sequenceNumber":
            suggest = "sequence_number"
        elif key == "sourceType":
            suggest = "source_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclTemplateInboundRule. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclTemplateInboundRule.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclTemplateInboundRule.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dst_port: str,
                 protocol: str,
                 src_port: str,
                 description: Optional[str] = None,
                 sequence_number: Optional[int] = None,
                 source_type: Optional[str] = None,
                 subnet: Optional[str] = None,
                 subnets: Optional[Sequence[str]] = None):
        """
        :param str dst_port: Inbound traffic destination ports. Allowed values are a comma separated list of ports, e.g., `20,22,23`, port range, e.g., `1023-1040` or word `any`.
        :param Union[str, 'AclRuleProtocolType'] protocol: Inbound traffic protocol. One of `IP`, `TCP`, `UDP`.
        :param str src_port: Inbound traffic source ports. Allowed values are a comma separated list of ports, e.g., `20,22,23`, port range, e.g., `1023-1040` or word `any`.
        :param str description: Inbound rule description, up to 200 characters.
        :param int sequence_number: Inbound rule sequence number
        :param str source_type: Type of traffic source used in a given inbound rule
        :param str subnet: Inbound traffic source IP subnet in CIDR format.
        :param Sequence[str] subnets: Inbound traffic source IP subnets in CIDR format.
        """
        pulumi.set(__self__, "dst_port", dst_port)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "src_port", src_port)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if sequence_number is not None:
            pulumi.set(__self__, "sequence_number", sequence_number)
        if source_type is not None:
            pulumi.set(__self__, "source_type", source_type)
        if subnet is not None:
            pulumi.set(__self__, "subnet", subnet)
        if subnets is not None:
            pulumi.set(__self__, "subnets", subnets)

    @property
    @pulumi.getter(name="dstPort")
    def dst_port(self) -> str:
        """
        Inbound traffic destination ports. Allowed values are a comma separated list of ports, e.g., `20,22,23`, port range, e.g., `1023-1040` or word `any`.
        """
        return pulumi.get(self, "dst_port")

    @property
    @pulumi.getter
    def protocol(self) -> str:
        """
        Inbound traffic protocol. One of `IP`, `TCP`, `UDP`.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="srcPort")
    def src_port(self) -> str:
        """
        Inbound traffic source ports. Allowed values are a comma separated list of ports, e.g., `20,22,23`, port range, e.g., `1023-1040` or word `any`.
        """
        return pulumi.get(self, "src_port")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Inbound rule description, up to 200 characters.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="sequenceNumber")
    def sequence_number(self) -> Optional[int]:
        """
        Inbound rule sequence number
        """
        return pulumi.get(self, "sequence_number")

    @property
    @pulumi.getter(name="sourceType")
    @_utilities.deprecated("""Source Type will not be returned""")
    def source_type(self) -> Optional[str]:
        """
        Type of traffic source used in a given inbound rule
        """
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter
    def subnet(self) -> Optional[str]:
        """
        Inbound traffic source IP subnet in CIDR format.
        """
        return pulumi.get(self, "subnet")

    @property
    @pulumi.getter
    @_utilities.deprecated("""Use Subnet instead""")
    def subnets(self) -> Optional[Sequence[str]]:
        """
        Inbound traffic source IP subnets in CIDR format.
        """
        return pulumi.get(self, "subnets")


@pulumi.output_type
class DeviceClusterDetails(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "clusterName":
            suggest = "cluster_name"
        elif key == "clusterId":
            suggest = "cluster_id"
        elif key == "numOfNodes":
            suggest = "num_of_nodes"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceClusterDetails. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceClusterDetails.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceClusterDetails.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 cluster_name: str,
                 node0: 'outputs.DeviceClusterDetailsNode0',
                 node1: 'outputs.DeviceClusterDetailsNode1',
                 cluster_id: Optional[str] = None,
                 num_of_nodes: Optional[int] = None):
        """
        :param str cluster_name: The name of the cluster device
        :param 'DeviceClusterDetailsNode0Args' node0: An object that has `node0` configuration. See Cluster Details - Nodes below for more details.
        :param 'DeviceClusterDetailsNode1Args' node1: An object that has `node1` configuration. See Cluster Details - Nodes below for more details.
        :param str cluster_id: The ID of the cluster.
        :param int num_of_nodes: The number of nodes in the cluster.
        """
        pulumi.set(__self__, "cluster_name", cluster_name)
        pulumi.set(__self__, "node0", node0)
        pulumi.set(__self__, "node1", node1)
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if num_of_nodes is not None:
            pulumi.set(__self__, "num_of_nodes", num_of_nodes)

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> str:
        """
        The name of the cluster device
        """
        return pulumi.get(self, "cluster_name")

    @property
    @pulumi.getter
    def node0(self) -> 'outputs.DeviceClusterDetailsNode0':
        """
        An object that has `node0` configuration. See Cluster Details - Nodes below for more details.
        """
        return pulumi.get(self, "node0")

    @property
    @pulumi.getter
    def node1(self) -> 'outputs.DeviceClusterDetailsNode1':
        """
        An object that has `node1` configuration. See Cluster Details - Nodes below for more details.
        """
        return pulumi.get(self, "node1")

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[str]:
        """
        The ID of the cluster.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="numOfNodes")
    def num_of_nodes(self) -> Optional[int]:
        """
        The number of nodes in the cluster.
        """
        return pulumi.get(self, "num_of_nodes")


@pulumi.output_type
class DeviceClusterDetailsNode0(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "licenseFileId":
            suggest = "license_file_id"
        elif key == "licenseToken":
            suggest = "license_token"
        elif key == "vendorConfiguration":
            suggest = "vendor_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceClusterDetailsNode0. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceClusterDetailsNode0.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceClusterDetailsNode0.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 license_file_id: Optional[str] = None,
                 license_token: Optional[str] = None,
                 name: Optional[str] = None,
                 uuid: Optional[str] = None,
                 vendor_configuration: Optional['outputs.DeviceClusterDetailsNode0VendorConfiguration'] = None):
        """
        :param str license_file_id: License file id. This is necessary for Fortinet and Juniper clusters.
        :param str license_token: License token. This is necessary for Palo Alto clusters.
        :param str name: Device name.
        :param str uuid: Device unique identifier.
        :param 'DeviceClusterDetailsNode0VendorConfigurationArgs' vendor_configuration: An object that has fields relevant to the vendor of the cluster device. See Cluster Details - Nodes - Vendor Configuration below for more details.
        """
        if license_file_id is not None:
            pulumi.set(__self__, "license_file_id", license_file_id)
        if license_token is not None:
            pulumi.set(__self__, "license_token", license_token)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)
        if vendor_configuration is not None:
            pulumi.set(__self__, "vendor_configuration", vendor_configuration)

    @property
    @pulumi.getter(name="licenseFileId")
    def license_file_id(self) -> Optional[str]:
        """
        License file id. This is necessary for Fortinet and Juniper clusters.
        """
        return pulumi.get(self, "license_file_id")

    @property
    @pulumi.getter(name="licenseToken")
    def license_token(self) -> Optional[str]:
        """
        License token. This is necessary for Palo Alto clusters.
        """
        return pulumi.get(self, "license_token")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Device name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def uuid(self) -> Optional[str]:
        """
        Device unique identifier.
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter(name="vendorConfiguration")
    def vendor_configuration(self) -> Optional['outputs.DeviceClusterDetailsNode0VendorConfiguration']:
        """
        An object that has fields relevant to the vendor of the cluster device. See Cluster Details - Nodes - Vendor Configuration below for more details.
        """
        return pulumi.get(self, "vendor_configuration")


@pulumi.output_type
class DeviceClusterDetailsNode0VendorConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "activationKey":
            suggest = "activation_key"
        elif key == "adminPassword":
            suggest = "admin_password"
        elif key == "controllerFqdn":
            suggest = "controller_fqdn"
        elif key == "licenseId":
            suggest = "license_id"
        elif key == "licenseKey":
            suggest = "license_key"
        elif key == "panoramaAuthKey":
            suggest = "panorama_auth_key"
        elif key == "panoramaIpAddress":
            suggest = "panorama_ip_address"
        elif key == "privateAddress":
            suggest = "private_address"
        elif key == "privateCidrMask":
            suggest = "private_cidr_mask"
        elif key == "privateGateway":
            suggest = "private_gateway"
        elif key == "rootPassword":
            suggest = "root_password"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceClusterDetailsNode0VendorConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceClusterDetailsNode0VendorConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceClusterDetailsNode0VendorConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 activation_key: Optional[str] = None,
                 admin_password: Optional[str] = None,
                 controller1: Optional[str] = None,
                 controller_fqdn: Optional[str] = None,
                 hostname: Optional[str] = None,
                 license_id: Optional[str] = None,
                 license_key: Optional[str] = None,
                 panorama_auth_key: Optional[str] = None,
                 panorama_ip_address: Optional[str] = None,
                 private_address: Optional[str] = None,
                 private_cidr_mask: Optional[str] = None,
                 private_gateway: Optional[str] = None,
                 root_password: Optional[str] = None):
        """
        :param str activation_key: Activation key. This is required for Velocloud clusters.
        :param str admin_password: The administrative password of the device. You can use it to log in to the console. This field is not available for all device types.
        :param str controller1: System IP Address. Mandatory for the Fortinet SDWAN cluster device.
        :param str controller_fqdn: Controller fqdn. This is required for Velocloud clusters.
        :param str hostname: Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters.
        :param str license_id: License id. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str license_key: License key. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str panorama_auth_key: Panorama Server Auth Key. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        :param str panorama_ip_address: Panorama Server IP Address. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        :param str private_address: Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_cidr_mask: Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_gateway: Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str root_password: The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster.
        """
        if activation_key is not None:
            pulumi.set(__self__, "activation_key", activation_key)
        if admin_password is not None:
            pulumi.set(__self__, "admin_password", admin_password)
        if controller1 is not None:
            pulumi.set(__self__, "controller1", controller1)
        if controller_fqdn is not None:
            pulumi.set(__self__, "controller_fqdn", controller_fqdn)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if license_id is not None:
            pulumi.set(__self__, "license_id", license_id)
        if license_key is not None:
            pulumi.set(__self__, "license_key", license_key)
        if panorama_auth_key is not None:
            pulumi.set(__self__, "panorama_auth_key", panorama_auth_key)
        if panorama_ip_address is not None:
            pulumi.set(__self__, "panorama_ip_address", panorama_ip_address)
        if private_address is not None:
            pulumi.set(__self__, "private_address", private_address)
        if private_cidr_mask is not None:
            pulumi.set(__self__, "private_cidr_mask", private_cidr_mask)
        if private_gateway is not None:
            pulumi.set(__self__, "private_gateway", private_gateway)
        if root_password is not None:
            pulumi.set(__self__, "root_password", root_password)

    @property
    @pulumi.getter(name="activationKey")
    def activation_key(self) -> Optional[str]:
        """
        Activation key. This is required for Velocloud clusters.
        """
        return pulumi.get(self, "activation_key")

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> Optional[str]:
        """
        The administrative password of the device. You can use it to log in to the console. This field is not available for all device types.
        """
        return pulumi.get(self, "admin_password")

    @property
    @pulumi.getter
    def controller1(self) -> Optional[str]:
        """
        System IP Address. Mandatory for the Fortinet SDWAN cluster device.
        """
        return pulumi.get(self, "controller1")

    @property
    @pulumi.getter(name="controllerFqdn")
    def controller_fqdn(self) -> Optional[str]:
        """
        Controller fqdn. This is required for Velocloud clusters.
        """
        return pulumi.get(self, "controller_fqdn")

    @property
    @pulumi.getter
    def hostname(self) -> Optional[str]:
        """
        Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="licenseId")
    def license_id(self) -> Optional[str]:
        """
        License id. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_id")

    @property
    @pulumi.getter(name="licenseKey")
    def license_key(self) -> Optional[str]:
        """
        License key. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_key")

    @property
    @pulumi.getter(name="panoramaAuthKey")
    def panorama_auth_key(self) -> Optional[str]:
        """
        Panorama Server Auth Key. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        """
        return pulumi.get(self, "panorama_auth_key")

    @property
    @pulumi.getter(name="panoramaIpAddress")
    def panorama_ip_address(self) -> Optional[str]:
        """
        Panorama Server IP Address. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        """
        return pulumi.get(self, "panorama_ip_address")

    @property
    @pulumi.getter(name="privateAddress")
    def private_address(self) -> Optional[str]:
        """
        Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_address")

    @property
    @pulumi.getter(name="privateCidrMask")
    def private_cidr_mask(self) -> Optional[str]:
        """
        Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_cidr_mask")

    @property
    @pulumi.getter(name="privateGateway")
    def private_gateway(self) -> Optional[str]:
        """
        Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_gateway")

    @property
    @pulumi.getter(name="rootPassword")
    def root_password(self) -> Optional[str]:
        """
        The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster.
        """
        return pulumi.get(self, "root_password")


@pulumi.output_type
class DeviceClusterDetailsNode1(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "licenseFileId":
            suggest = "license_file_id"
        elif key == "licenseToken":
            suggest = "license_token"
        elif key == "vendorConfiguration":
            suggest = "vendor_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceClusterDetailsNode1. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceClusterDetailsNode1.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceClusterDetailsNode1.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 license_file_id: Optional[str] = None,
                 license_token: Optional[str] = None,
                 name: Optional[str] = None,
                 uuid: Optional[str] = None,
                 vendor_configuration: Optional['outputs.DeviceClusterDetailsNode1VendorConfiguration'] = None):
        """
        :param str license_file_id: License file id. This is necessary for Fortinet and Juniper clusters.
        :param str license_token: License token. This is necessary for Palo Alto clusters.
        :param str name: Device name.
        :param str uuid: Device unique identifier.
        :param 'DeviceClusterDetailsNode1VendorConfigurationArgs' vendor_configuration: An object that has fields relevant to the vendor of the cluster device. See Cluster Details - Nodes - Vendor Configuration below for more details.
        """
        if license_file_id is not None:
            pulumi.set(__self__, "license_file_id", license_file_id)
        if license_token is not None:
            pulumi.set(__self__, "license_token", license_token)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)
        if vendor_configuration is not None:
            pulumi.set(__self__, "vendor_configuration", vendor_configuration)

    @property
    @pulumi.getter(name="licenseFileId")
    def license_file_id(self) -> Optional[str]:
        """
        License file id. This is necessary for Fortinet and Juniper clusters.
        """
        return pulumi.get(self, "license_file_id")

    @property
    @pulumi.getter(name="licenseToken")
    def license_token(self) -> Optional[str]:
        """
        License token. This is necessary for Palo Alto clusters.
        """
        return pulumi.get(self, "license_token")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Device name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def uuid(self) -> Optional[str]:
        """
        Device unique identifier.
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter(name="vendorConfiguration")
    def vendor_configuration(self) -> Optional['outputs.DeviceClusterDetailsNode1VendorConfiguration']:
        """
        An object that has fields relevant to the vendor of the cluster device. See Cluster Details - Nodes - Vendor Configuration below for more details.
        """
        return pulumi.get(self, "vendor_configuration")


@pulumi.output_type
class DeviceClusterDetailsNode1VendorConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "activationKey":
            suggest = "activation_key"
        elif key == "adminPassword":
            suggest = "admin_password"
        elif key == "controllerFqdn":
            suggest = "controller_fqdn"
        elif key == "licenseId":
            suggest = "license_id"
        elif key == "licenseKey":
            suggest = "license_key"
        elif key == "panoramaAuthKey":
            suggest = "panorama_auth_key"
        elif key == "panoramaIpAddress":
            suggest = "panorama_ip_address"
        elif key == "privateAddress":
            suggest = "private_address"
        elif key == "privateCidrMask":
            suggest = "private_cidr_mask"
        elif key == "privateGateway":
            suggest = "private_gateway"
        elif key == "rootPassword":
            suggest = "root_password"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceClusterDetailsNode1VendorConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceClusterDetailsNode1VendorConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceClusterDetailsNode1VendorConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 activation_key: Optional[str] = None,
                 admin_password: Optional[str] = None,
                 controller1: Optional[str] = None,
                 controller_fqdn: Optional[str] = None,
                 hostname: Optional[str] = None,
                 license_id: Optional[str] = None,
                 license_key: Optional[str] = None,
                 panorama_auth_key: Optional[str] = None,
                 panorama_ip_address: Optional[str] = None,
                 private_address: Optional[str] = None,
                 private_cidr_mask: Optional[str] = None,
                 private_gateway: Optional[str] = None,
                 root_password: Optional[str] = None):
        """
        :param str activation_key: Activation key. This is required for Velocloud clusters.
        :param str admin_password: The administrative password of the device. You can use it to log in to the console. This field is not available for all device types.
        :param str controller1: System IP Address. Mandatory for the Fortinet SDWAN cluster device.
        :param str controller_fqdn: Controller fqdn. This is required for Velocloud clusters.
        :param str hostname: Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters.
        :param str license_id: License id. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str license_key: License key. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str panorama_auth_key: Panorama Server Auth Key. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        :param str panorama_ip_address: Panorama Server IP Address. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        :param str private_address: Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_cidr_mask: Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_gateway: Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str root_password: The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster.
        """
        if activation_key is not None:
            pulumi.set(__self__, "activation_key", activation_key)
        if admin_password is not None:
            pulumi.set(__self__, "admin_password", admin_password)
        if controller1 is not None:
            pulumi.set(__self__, "controller1", controller1)
        if controller_fqdn is not None:
            pulumi.set(__self__, "controller_fqdn", controller_fqdn)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if license_id is not None:
            pulumi.set(__self__, "license_id", license_id)
        if license_key is not None:
            pulumi.set(__self__, "license_key", license_key)
        if panorama_auth_key is not None:
            pulumi.set(__self__, "panorama_auth_key", panorama_auth_key)
        if panorama_ip_address is not None:
            pulumi.set(__self__, "panorama_ip_address", panorama_ip_address)
        if private_address is not None:
            pulumi.set(__self__, "private_address", private_address)
        if private_cidr_mask is not None:
            pulumi.set(__self__, "private_cidr_mask", private_cidr_mask)
        if private_gateway is not None:
            pulumi.set(__self__, "private_gateway", private_gateway)
        if root_password is not None:
            pulumi.set(__self__, "root_password", root_password)

    @property
    @pulumi.getter(name="activationKey")
    def activation_key(self) -> Optional[str]:
        """
        Activation key. This is required for Velocloud clusters.
        """
        return pulumi.get(self, "activation_key")

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> Optional[str]:
        """
        The administrative password of the device. You can use it to log in to the console. This field is not available for all device types.
        """
        return pulumi.get(self, "admin_password")

    @property
    @pulumi.getter
    def controller1(self) -> Optional[str]:
        """
        System IP Address. Mandatory for the Fortinet SDWAN cluster device.
        """
        return pulumi.get(self, "controller1")

    @property
    @pulumi.getter(name="controllerFqdn")
    def controller_fqdn(self) -> Optional[str]:
        """
        Controller fqdn. This is required for Velocloud clusters.
        """
        return pulumi.get(self, "controller_fqdn")

    @property
    @pulumi.getter
    def hostname(self) -> Optional[str]:
        """
        Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="licenseId")
    def license_id(self) -> Optional[str]:
        """
        License id. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_id")

    @property
    @pulumi.getter(name="licenseKey")
    def license_key(self) -> Optional[str]:
        """
        License key. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_key")

    @property
    @pulumi.getter(name="panoramaAuthKey")
    def panorama_auth_key(self) -> Optional[str]:
        """
        Panorama Server Auth Key. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        """
        return pulumi.get(self, "panorama_auth_key")

    @property
    @pulumi.getter(name="panoramaIpAddress")
    def panorama_ip_address(self) -> Optional[str]:
        """
        Panorama Server IP Address. This field is relevant only for the PA-VM firewall devices to have integration with Panorama Server.
        """
        return pulumi.get(self, "panorama_ip_address")

    @property
    @pulumi.getter(name="privateAddress")
    def private_address(self) -> Optional[str]:
        """
        Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_address")

    @property
    @pulumi.getter(name="privateCidrMask")
    def private_cidr_mask(self) -> Optional[str]:
        """
        Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_cidr_mask")

    @property
    @pulumi.getter(name="privateGateway")
    def private_gateway(self) -> Optional[str]:
        """
        Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_gateway")

    @property
    @pulumi.getter(name="rootPassword")
    def root_password(self) -> Optional[str]:
        """
        The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster.
        """
        return pulumi.get(self, "root_password")


@pulumi.output_type
class DeviceInterface(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "assignedType":
            suggest = "assigned_type"
        elif key == "ipAddress":
            suggest = "ip_address"
        elif key == "macAddress":
            suggest = "mac_address"
        elif key == "operationalStatus":
            suggest = "operational_status"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceInterface. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceInterface.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceInterface.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 assigned_type: Optional[str] = None,
                 id: Optional[int] = None,
                 ip_address: Optional[str] = None,
                 mac_address: Optional[str] = None,
                 name: Optional[str] = None,
                 operational_status: Optional[str] = None,
                 status: Optional[str] = None,
                 type: Optional[str] = None):
        """
        :param str assigned_type: interface management type (Equinix Managed or empty).
        :param int id: interface identifier.
        :param str ip_address: interface IP address.
        :param str mac_address: interface MAC address.
        :param str name: Device name.
        :param str operational_status: interface operational status. One of `up`, `down`.
        :param str status: interface status. One of `AVAILABLE`, `RESERVED`, `ASSIGNED`.
        :param str type: interface type.
        """
        if assigned_type is not None:
            pulumi.set(__self__, "assigned_type", assigned_type)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if ip_address is not None:
            pulumi.set(__self__, "ip_address", ip_address)
        if mac_address is not None:
            pulumi.set(__self__, "mac_address", mac_address)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if operational_status is not None:
            pulumi.set(__self__, "operational_status", operational_status)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="assignedType")
    def assigned_type(self) -> Optional[str]:
        """
        interface management type (Equinix Managed or empty).
        """
        return pulumi.get(self, "assigned_type")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        interface identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> Optional[str]:
        """
        interface IP address.
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter(name="macAddress")
    def mac_address(self) -> Optional[str]:
        """
        interface MAC address.
        """
        return pulumi.get(self, "mac_address")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Device name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="operationalStatus")
    def operational_status(self) -> Optional[str]:
        """
        interface operational status. One of `up`, `down`.
        """
        return pulumi.get(self, "operational_status")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        interface status. One of `AVAILABLE`, `RESERVED`, `ASSIGNED`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        interface type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class DeviceLinkDevice(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "interfaceId":
            suggest = "interface_id"
        elif key == "ipAddress":
            suggest = "ip_address"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceLinkDevice. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceLinkDevice.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceLinkDevice.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 id: str,
                 asn: Optional[int] = None,
                 interface_id: Optional[int] = None,
                 ip_address: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str id: Device identifier.
        :param int asn: Device ASN number. Not required for self configured devices.
        :param int interface_id: Device network interface identifier to use for device link connection.
        :param str ip_address: IP address from device link subnet that was assigned to the device
        :param str status: device link provisioning status on a given device. One of `PROVISIONING`, `PROVISIONED`, `DEPROVISIONING`, `DEPROVISIONED`, `FAILED`.
        """
        pulumi.set(__self__, "id", id)
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if interface_id is not None:
            pulumi.set(__self__, "interface_id", interface_id)
        if ip_address is not None:
            pulumi.set(__self__, "ip_address", ip_address)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Device identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def asn(self) -> Optional[int]:
        """
        Device ASN number. Not required for self configured devices.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter(name="interfaceId")
    def interface_id(self) -> Optional[int]:
        """
        Device network interface identifier to use for device link connection.
        """
        return pulumi.get(self, "interface_id")

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> Optional[str]:
        """
        IP address from device link subnet that was assigned to the device
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        device link provisioning status on a given device. One of `PROVISIONING`, `PROVISIONED`, `DEPROVISIONING`, `DEPROVISIONED`, `FAILED`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class DeviceLinkLink(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "accountNumber":
            suggest = "account_number"
        elif key == "dstMetroCode":
            suggest = "dst_metro_code"
        elif key == "srcMetroCode":
            suggest = "src_metro_code"
        elif key == "throughputUnit":
            suggest = "throughput_unit"
        elif key == "dstZoneCode":
            suggest = "dst_zone_code"
        elif key == "srcZoneCode":
            suggest = "src_zone_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceLinkLink. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceLinkLink.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceLinkLink.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 account_number: str,
                 dst_metro_code: str,
                 src_metro_code: str,
                 throughput: str,
                 throughput_unit: str,
                 dst_zone_code: Optional[str] = None,
                 src_zone_code: Optional[str] = None):
        """
        :param str account_number: billing account number to be used for connection charges
        :param str dst_metro_code: connection destination metro code.
        :param str src_metro_code: connection source metro code.
        :param str throughput: connection throughput.
        :param str throughput_unit: connection throughput unit (Mbps or Gbps).
        :param str dst_zone_code: connection destination zone code is not required.
        :param str src_zone_code: connection source zone code is not required.
        """
        pulumi.set(__self__, "account_number", account_number)
        pulumi.set(__self__, "dst_metro_code", dst_metro_code)
        pulumi.set(__self__, "src_metro_code", src_metro_code)
        pulumi.set(__self__, "throughput", throughput)
        pulumi.set(__self__, "throughput_unit", throughput_unit)
        if dst_zone_code is not None:
            pulumi.set(__self__, "dst_zone_code", dst_zone_code)
        if src_zone_code is not None:
            pulumi.set(__self__, "src_zone_code", src_zone_code)

    @property
    @pulumi.getter(name="accountNumber")
    def account_number(self) -> str:
        """
        billing account number to be used for connection charges
        """
        return pulumi.get(self, "account_number")

    @property
    @pulumi.getter(name="dstMetroCode")
    def dst_metro_code(self) -> str:
        """
        connection destination metro code.
        """
        return pulumi.get(self, "dst_metro_code")

    @property
    @pulumi.getter(name="srcMetroCode")
    def src_metro_code(self) -> str:
        """
        connection source metro code.
        """
        return pulumi.get(self, "src_metro_code")

    @property
    @pulumi.getter
    def throughput(self) -> str:
        """
        connection throughput.
        """
        return pulumi.get(self, "throughput")

    @property
    @pulumi.getter(name="throughputUnit")
    def throughput_unit(self) -> str:
        """
        connection throughput unit (Mbps or Gbps).
        """
        return pulumi.get(self, "throughput_unit")

    @property
    @pulumi.getter(name="dstZoneCode")
    @_utilities.deprecated("""DestinationZoneCode is not required""")
    def dst_zone_code(self) -> Optional[str]:
        """
        connection destination zone code is not required.
        """
        return pulumi.get(self, "dst_zone_code")

    @property
    @pulumi.getter(name="srcZoneCode")
    @_utilities.deprecated("""SourceZoneCode is not required""")
    def src_zone_code(self) -> Optional[str]:
        """
        connection source zone code is not required.
        """
        return pulumi.get(self, "src_zone_code")


@pulumi.output_type
class DeviceLinkMetroLink(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "accountNumber":
            suggest = "account_number"
        elif key == "metroCode":
            suggest = "metro_code"
        elif key == "throughputUnit":
            suggest = "throughput_unit"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceLinkMetroLink. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceLinkMetroLink.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceLinkMetroLink.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 account_number: str,
                 metro_code: str,
                 throughput: str,
                 throughput_unit: str):
        """
        :param str account_number: billing account number to be used for connection charges
        :param str metro_code: connection metro code.
        :param str throughput: connection throughput.
        :param str throughput_unit: connection throughput unit (Mbps or Gbps).
        """
        pulumi.set(__self__, "account_number", account_number)
        pulumi.set(__self__, "metro_code", metro_code)
        pulumi.set(__self__, "throughput", throughput)
        pulumi.set(__self__, "throughput_unit", throughput_unit)

    @property
    @pulumi.getter(name="accountNumber")
    def account_number(self) -> str:
        """
        billing account number to be used for connection charges
        """
        return pulumi.get(self, "account_number")

    @property
    @pulumi.getter(name="metroCode")
    def metro_code(self) -> str:
        """
        connection metro code.
        """
        return pulumi.get(self, "metro_code")

    @property
    @pulumi.getter
    def throughput(self) -> str:
        """
        connection throughput.
        """
        return pulumi.get(self, "throughput")

    @property
    @pulumi.getter(name="throughputUnit")
    def throughput_unit(self) -> str:
        """
        connection throughput unit (Mbps or Gbps).
        """
        return pulumi.get(self, "throughput_unit")


@pulumi.output_type
class DeviceSecondaryDevice(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "accountNumber":
            suggest = "account_number"
        elif key == "metroCode":
            suggest = "metro_code"
        elif key == "aclTemplateId":
            suggest = "acl_template_id"
        elif key == "additionalBandwidth":
            suggest = "additional_bandwidth"
        elif key == "cloudInitFileId":
            suggest = "cloud_init_file_id"
        elif key == "licenseFile":
            suggest = "license_file"
        elif key == "licenseFileId":
            suggest = "license_file_id"
        elif key == "licenseStatus":
            suggest = "license_status"
        elif key == "licenseToken":
            suggest = "license_token"
        elif key == "mgmtAclTemplateUuid":
            suggest = "mgmt_acl_template_uuid"
        elif key == "projectId":
            suggest = "project_id"
        elif key == "redundancyType":
            suggest = "redundancy_type"
        elif key == "redundantId":
            suggest = "redundant_id"
        elif key == "sshIpAddress":
            suggest = "ssh_ip_address"
        elif key == "sshIpFqdn":
            suggest = "ssh_ip_fqdn"
        elif key == "sshKey":
            suggest = "ssh_key"
        elif key == "vendorConfiguration":
            suggest = "vendor_configuration"
        elif key == "wanInterfaceId":
            suggest = "wan_interface_id"
        elif key == "zoneCode":
            suggest = "zone_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceSecondaryDevice. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceSecondaryDevice.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceSecondaryDevice.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 account_number: str,
                 metro_code: str,
                 name: str,
                 notifications: Sequence[str],
                 acl_template_id: Optional[str] = None,
                 additional_bandwidth: Optional[int] = None,
                 asn: Optional[int] = None,
                 cloud_init_file_id: Optional[str] = None,
                 hostname: Optional[str] = None,
                 ibx: Optional[str] = None,
                 interfaces: Optional[Sequence['outputs.DeviceSecondaryDeviceInterface']] = None,
                 license_file: Optional[str] = None,
                 license_file_id: Optional[str] = None,
                 license_status: Optional[str] = None,
                 license_token: Optional[str] = None,
                 mgmt_acl_template_uuid: Optional[str] = None,
                 project_id: Optional[str] = None,
                 redundancy_type: Optional[str] = None,
                 redundant_id: Optional[str] = None,
                 region: Optional[str] = None,
                 ssh_ip_address: Optional[str] = None,
                 ssh_ip_fqdn: Optional[str] = None,
                 ssh_key: Optional['outputs.DeviceSecondaryDeviceSshKey'] = None,
                 status: Optional[str] = None,
                 uuid: Optional[str] = None,
                 vendor_configuration: Optional[Mapping[str, str]] = None,
                 wan_interface_id: Optional[str] = None,
                 zone_code: Optional[str] = None):
        """
        :param str account_number: Billing account number for secondary device.
        :param str metro_code: Metro location of a secondary device.
        :param str name: Secondary device name.
        :param Sequence[str] notifications: List of email addresses that will receive notifications about secondary device.
        :param str acl_template_id: Identifier of a WAN interface ACL template that will be applied on a secondary device.
        :param int additional_bandwidth: Additional Internet bandwidth, in Mbps, for a secondary device.
        :param int asn: (Autonomous System Number) Unique identifier for a network on the internet.
        :param str cloud_init_file_id: Identifier of a cloud init file that will be applied on a secondary device.
        :param str hostname: Secondary device hostname.
        :param str ibx: Device location Equinix Business Exchange name.
        :param Sequence['DeviceSecondaryDeviceInterfaceArgs'] interfaces: List of device interfaces. See Interface Attribute below for more details.
        :param str license_file: Path to the license file that will be uploaded and applied on a secondary device. Applicable for some device types in BYOL licensing mode.
        :param str license_file_id: Identifier of a license file that will be applied on a secondary device.
        :param str license_status: Device license registration status. Possible values are `APPLYING_LICENSE`, `REGISTERED`, `APPLIED`, `WAITING_FOR_CLUSTER_SETUP`, `REGISTRATION_FAILED`.
        :param str license_token: License Token can be provided for some device types o the device.
        :param str mgmt_acl_template_uuid: Identifier of an MGMT interface ACL template that will be applied on a secondary device.
               * `ssh-key` - (Optional) Up to one definition of SSH key that will be provisioned on a secondary device.
        :param str project_id: Unique Identifier for the project resource where the device is scoped to.If you leave it out, the device will be created under the default project id of your organization.
        :param str redundancy_type: Device redundancy type applicable for HA devices, either primary or secondary.
        :param str redundant_id: Unique identifier for a redundant device applicable for HA devices.
        :param str region: Device location region.
        :param str ssh_ip_address: IP address of SSH enabled interface on the device.
        :param str ssh_ip_fqdn: FQDN of SSH enabled interface on the device.
        :param 'DeviceSecondaryDeviceSshKeyArgs' ssh_key: Definition of SSH key that will be provisioned on a device
        :param str status: interface status. One of `AVAILABLE`, `RESERVED`, `ASSIGNED`.
        :param str uuid: Device unique identifier.
        :param Mapping[str, str] vendor_configuration: Key/Value pairs of vendor specific configuration parameters for a secondary device. Key values are `controller1`, `activationKey`, `managementType`, `siteId`, `systemIpAddress`, `privateAddress`, `privateCidrMask`, `privateGateway`, `licenseKey`, `licenseId`, `panoramaAuthKey`, `panoramaIpAddress`.
        :param str wan_interface_id: device interface id picked for WAN
        :param str zone_code: Device location zone code.
        """
        pulumi.set(__self__, "account_number", account_number)
        pulumi.set(__self__, "metro_code", metro_code)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "notifications", notifications)
        if acl_template_id is not None:
            pulumi.set(__self__, "acl_template_id", acl_template_id)
        if additional_bandwidth is not None:
            pulumi.set(__self__, "additional_bandwidth", additional_bandwidth)
        if asn is not None:
            pulumi.set(__self__, "asn", asn)
        if cloud_init_file_id is not None:
            pulumi.set(__self__, "cloud_init_file_id", cloud_init_file_id)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if ibx is not None:
            pulumi.set(__self__, "ibx", ibx)
        if interfaces is not None:
            pulumi.set(__self__, "interfaces", interfaces)
        if license_file is not None:
            pulumi.set(__self__, "license_file", license_file)
        if license_file_id is not None:
            pulumi.set(__self__, "license_file_id", license_file_id)
        if license_status is not None:
            pulumi.set(__self__, "license_status", license_status)
        if license_token is not None:
            pulumi.set(__self__, "license_token", license_token)
        if mgmt_acl_template_uuid is not None:
            pulumi.set(__self__, "mgmt_acl_template_uuid", mgmt_acl_template_uuid)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if redundancy_type is not None:
            pulumi.set(__self__, "redundancy_type", redundancy_type)
        if redundant_id is not None:
            pulumi.set(__self__, "redundant_id", redundant_id)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if ssh_ip_address is not None:
            pulumi.set(__self__, "ssh_ip_address", ssh_ip_address)
        if ssh_ip_fqdn is not None:
            pulumi.set(__self__, "ssh_ip_fqdn", ssh_ip_fqdn)
        if ssh_key is not None:
            pulumi.set(__self__, "ssh_key", ssh_key)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)
        if vendor_configuration is not None:
            pulumi.set(__self__, "vendor_configuration", vendor_configuration)
        if wan_interface_id is not None:
            pulumi.set(__self__, "wan_interface_id", wan_interface_id)
        if zone_code is not None:
            pulumi.set(__self__, "zone_code", zone_code)

    @property
    @pulumi.getter(name="accountNumber")
    def account_number(self) -> str:
        """
        Billing account number for secondary device.
        """
        return pulumi.get(self, "account_number")

    @property
    @pulumi.getter(name="metroCode")
    def metro_code(self) -> str:
        """
        Metro location of a secondary device.
        """
        return pulumi.get(self, "metro_code")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Secondary device name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def notifications(self) -> Sequence[str]:
        """
        List of email addresses that will receive notifications about secondary device.
        """
        return pulumi.get(self, "notifications")

    @property
    @pulumi.getter(name="aclTemplateId")
    def acl_template_id(self) -> Optional[str]:
        """
        Identifier of a WAN interface ACL template that will be applied on a secondary device.
        """
        return pulumi.get(self, "acl_template_id")

    @property
    @pulumi.getter(name="additionalBandwidth")
    def additional_bandwidth(self) -> Optional[int]:
        """
        Additional Internet bandwidth, in Mbps, for a secondary device.
        """
        return pulumi.get(self, "additional_bandwidth")

    @property
    @pulumi.getter
    def asn(self) -> Optional[int]:
        """
        (Autonomous System Number) Unique identifier for a network on the internet.
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter(name="cloudInitFileId")
    def cloud_init_file_id(self) -> Optional[str]:
        """
        Identifier of a cloud init file that will be applied on a secondary device.
        """
        return pulumi.get(self, "cloud_init_file_id")

    @property
    @pulumi.getter
    def hostname(self) -> Optional[str]:
        """
        Secondary device hostname.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter
    def ibx(self) -> Optional[str]:
        """
        Device location Equinix Business Exchange name.
        """
        return pulumi.get(self, "ibx")

    @property
    @pulumi.getter
    def interfaces(self) -> Optional[Sequence['outputs.DeviceSecondaryDeviceInterface']]:
        """
        List of device interfaces. See Interface Attribute below for more details.
        """
        return pulumi.get(self, "interfaces")

    @property
    @pulumi.getter(name="licenseFile")
    def license_file(self) -> Optional[str]:
        """
        Path to the license file that will be uploaded and applied on a secondary device. Applicable for some device types in BYOL licensing mode.
        """
        return pulumi.get(self, "license_file")

    @property
    @pulumi.getter(name="licenseFileId")
    def license_file_id(self) -> Optional[str]:
        """
        Identifier of a license file that will be applied on a secondary device.
        """
        return pulumi.get(self, "license_file_id")

    @property
    @pulumi.getter(name="licenseStatus")
    def license_status(self) -> Optional[str]:
        """
        Device license registration status. Possible values are `APPLYING_LICENSE`, `REGISTERED`, `APPLIED`, `WAITING_FOR_CLUSTER_SETUP`, `REGISTRATION_FAILED`.
        """
        return pulumi.get(self, "license_status")

    @property
    @pulumi.getter(name="licenseToken")
    def license_token(self) -> Optional[str]:
        """
        License Token can be provided for some device types o the device.
        """
        return pulumi.get(self, "license_token")

    @property
    @pulumi.getter(name="mgmtAclTemplateUuid")
    def mgmt_acl_template_uuid(self) -> Optional[str]:
        """
        Identifier of an MGMT interface ACL template that will be applied on a secondary device.
        * `ssh-key` - (Optional) Up to one definition of SSH key that will be provisioned on a secondary device.
        """
        return pulumi.get(self, "mgmt_acl_template_uuid")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[str]:
        """
        Unique Identifier for the project resource where the device is scoped to.If you leave it out, the device will be created under the default project id of your organization.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="redundancyType")
    def redundancy_type(self) -> Optional[str]:
        """
        Device redundancy type applicable for HA devices, either primary or secondary.
        """
        return pulumi.get(self, "redundancy_type")

    @property
    @pulumi.getter(name="redundantId")
    def redundant_id(self) -> Optional[str]:
        """
        Unique identifier for a redundant device applicable for HA devices.
        """
        return pulumi.get(self, "redundant_id")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        """
        Device location region.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="sshIpAddress")
    def ssh_ip_address(self) -> Optional[str]:
        """
        IP address of SSH enabled interface on the device.
        """
        return pulumi.get(self, "ssh_ip_address")

    @property
    @pulumi.getter(name="sshIpFqdn")
    def ssh_ip_fqdn(self) -> Optional[str]:
        """
        FQDN of SSH enabled interface on the device.
        """
        return pulumi.get(self, "ssh_ip_fqdn")

    @property
    @pulumi.getter(name="sshKey")
    def ssh_key(self) -> Optional['outputs.DeviceSecondaryDeviceSshKey']:
        """
        Definition of SSH key that will be provisioned on a device
        """
        return pulumi.get(self, "ssh_key")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        interface status. One of `AVAILABLE`, `RESERVED`, `ASSIGNED`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def uuid(self) -> Optional[str]:
        """
        Device unique identifier.
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter(name="vendorConfiguration")
    def vendor_configuration(self) -> Optional[Mapping[str, str]]:
        """
        Key/Value pairs of vendor specific configuration parameters for a secondary device. Key values are `controller1`, `activationKey`, `managementType`, `siteId`, `systemIpAddress`, `privateAddress`, `privateCidrMask`, `privateGateway`, `licenseKey`, `licenseId`, `panoramaAuthKey`, `panoramaIpAddress`.
        """
        return pulumi.get(self, "vendor_configuration")

    @property
    @pulumi.getter(name="wanInterfaceId")
    def wan_interface_id(self) -> Optional[str]:
        """
        device interface id picked for WAN
        """
        return pulumi.get(self, "wan_interface_id")

    @property
    @pulumi.getter(name="zoneCode")
    def zone_code(self) -> Optional[str]:
        """
        Device location zone code.
        """
        return pulumi.get(self, "zone_code")


@pulumi.output_type
class DeviceSecondaryDeviceInterface(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "assignedType":
            suggest = "assigned_type"
        elif key == "ipAddress":
            suggest = "ip_address"
        elif key == "macAddress":
            suggest = "mac_address"
        elif key == "operationalStatus":
            suggest = "operational_status"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceSecondaryDeviceInterface. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceSecondaryDeviceInterface.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceSecondaryDeviceInterface.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 assigned_type: Optional[str] = None,
                 id: Optional[int] = None,
                 ip_address: Optional[str] = None,
                 mac_address: Optional[str] = None,
                 name: Optional[str] = None,
                 operational_status: Optional[str] = None,
                 status: Optional[str] = None,
                 type: Optional[str] = None):
        """
        :param str assigned_type: interface management type (Equinix Managed or empty).
        :param int id: interface identifier.
        :param str ip_address: interface IP address.
        :param str mac_address: interface MAC address.
        :param str name: Device name.
        :param str operational_status: interface operational status. One of `up`, `down`.
        :param str status: interface status. One of `AVAILABLE`, `RESERVED`, `ASSIGNED`.
        :param str type: interface type.
        """
        if assigned_type is not None:
            pulumi.set(__self__, "assigned_type", assigned_type)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if ip_address is not None:
            pulumi.set(__self__, "ip_address", ip_address)
        if mac_address is not None:
            pulumi.set(__self__, "mac_address", mac_address)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if operational_status is not None:
            pulumi.set(__self__, "operational_status", operational_status)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="assignedType")
    def assigned_type(self) -> Optional[str]:
        """
        interface management type (Equinix Managed or empty).
        """
        return pulumi.get(self, "assigned_type")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        interface identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> Optional[str]:
        """
        interface IP address.
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter(name="macAddress")
    def mac_address(self) -> Optional[str]:
        """
        interface MAC address.
        """
        return pulumi.get(self, "mac_address")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Device name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="operationalStatus")
    def operational_status(self) -> Optional[str]:
        """
        interface operational status. One of `up`, `down`.
        """
        return pulumi.get(self, "operational_status")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        interface status. One of `AVAILABLE`, `RESERVED`, `ASSIGNED`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        interface type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class DeviceSecondaryDeviceSshKey(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "keyName":
            suggest = "key_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceSecondaryDeviceSshKey. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceSecondaryDeviceSshKey.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceSecondaryDeviceSshKey.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 key_name: str,
                 username: str):
        """
        :param str key_name: Reference by name to previously provisioned public SSH key
        :param str username: username associated with given key.
        """
        pulumi.set(__self__, "key_name", key_name)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="keyName")
    def key_name(self) -> str:
        """
        Reference by name to previously provisioned public SSH key
        """
        return pulumi.get(self, "key_name")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        username associated with given key.
        """
        return pulumi.get(self, "username")


@pulumi.output_type
class DeviceSshKey(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "keyName":
            suggest = "key_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeviceSshKey. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeviceSshKey.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeviceSshKey.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 key_name: str,
                 username: str):
        """
        :param str key_name: Reference by name to previously provisioned public SSH key
        :param str username: username associated with given key.
        """
        pulumi.set(__self__, "key_name", key_name)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="keyName")
    def key_name(self) -> str:
        """
        Reference by name to previously provisioned public SSH key
        """
        return pulumi.get(self, "key_name")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        username associated with given key.
        """
        return pulumi.get(self, "username")


@pulumi.output_type
class GetDeviceClusterDetailResult(dict):
    def __init__(__self__, *,
                 cluster_id: str,
                 cluster_name: str,
                 node0s: Sequence['outputs.GetDeviceClusterDetailNode0Result'],
                 node1s: Sequence['outputs.GetDeviceClusterDetailNode1Result'],
                 num_of_nodes: int):
        """
        :param str cluster_id: The id of the cluster
        :param str cluster_name: The name of the cluster device
        :param Sequence['GetDeviceClusterDetailNode0Args'] node0s: An object that has node0 details
        :param Sequence['GetDeviceClusterDetailNode1Args'] node1s: An object that has node1 details
        :param int num_of_nodes: The number of nodes in the cluster
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        pulumi.set(__self__, "cluster_name", cluster_name)
        pulumi.set(__self__, "node0s", node0s)
        pulumi.set(__self__, "node1s", node1s)
        pulumi.set(__self__, "num_of_nodes", num_of_nodes)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        """
        The id of the cluster
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="clusterName")
    def cluster_name(self) -> str:
        """
        The name of the cluster device
        """
        return pulumi.get(self, "cluster_name")

    @property
    @pulumi.getter
    def node0s(self) -> Sequence['outputs.GetDeviceClusterDetailNode0Result']:
        """
        An object that has node0 details
        """
        return pulumi.get(self, "node0s")

    @property
    @pulumi.getter
    def node1s(self) -> Sequence['outputs.GetDeviceClusterDetailNode1Result']:
        """
        An object that has node1 details
        """
        return pulumi.get(self, "node1s")

    @property
    @pulumi.getter(name="numOfNodes")
    def num_of_nodes(self) -> int:
        """
        The number of nodes in the cluster
        """
        return pulumi.get(self, "num_of_nodes")


@pulumi.output_type
class GetDeviceClusterDetailNode0Result(dict):
    def __init__(__self__, *,
                 license_file_id: str,
                 license_token: str,
                 name: str,
                 uuid: str,
                 vendor_configurations: Sequence['outputs.GetDeviceClusterDetailNode0VendorConfigurationResult']):
        """
        :param str license_file_id: Unique identifier of applied license file
        :param str license_token: License token. This is necessary for Palo Alto clusters
        :param str name: Name of an existing Equinix Network Edge device
        :param str uuid: UUID of an existing Equinix Network Edge device
        :param Sequence['GetDeviceClusterDetailNode0VendorConfigurationArgs'] vendor_configurations: An object that has fields relevant to the vendor of the cluster device
        """
        pulumi.set(__self__, "license_file_id", license_file_id)
        pulumi.set(__self__, "license_token", license_token)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "uuid", uuid)
        pulumi.set(__self__, "vendor_configurations", vendor_configurations)

    @property
    @pulumi.getter(name="licenseFileId")
    def license_file_id(self) -> str:
        """
        Unique identifier of applied license file
        """
        return pulumi.get(self, "license_file_id")

    @property
    @pulumi.getter(name="licenseToken")
    def license_token(self) -> str:
        """
        License token. This is necessary for Palo Alto clusters
        """
        return pulumi.get(self, "license_token")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def uuid(self) -> str:
        """
        UUID of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter(name="vendorConfigurations")
    def vendor_configurations(self) -> Sequence['outputs.GetDeviceClusterDetailNode0VendorConfigurationResult']:
        """
        An object that has fields relevant to the vendor of the cluster device
        """
        return pulumi.get(self, "vendor_configurations")


@pulumi.output_type
class GetDeviceClusterDetailNode0VendorConfigurationResult(dict):
    def __init__(__self__, *,
                 activation_key: str,
                 admin_password: str,
                 controller1: str,
                 controller_fqdn: str,
                 hostname: str,
                 license_id: str,
                 license_key: str,
                 panorama_auth_key: str,
                 panorama_ip_address: str,
                 private_address: str,
                 private_cidr_mask: str,
                 private_gateway: str,
                 root_password: str):
        """
        :param str activation_key: Activation key. This is required for Velocloud clusters
        :param str admin_password: The administrative password of the device. You can use it to log in to the console. This field is not available for all device types
        :param str controller1: System IP Address. Mandatory for the Fortinet SDWAN cluster device
        :param str controller_fqdn: Controller fqdn. This is required for Velocloud clusters
        :param str hostname: Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters
        :param str license_id: License id. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str license_key: License key. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str panorama_auth_key: Panorama Server Auth Key. This field is relevant only for Palo Alto Networks Firewall devices
        :param str panorama_ip_address: Panorama Server IP Address. This field is relevant only for Palo Alto Networks Firewall devices
        :param str private_address: Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_cidr_mask: Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_gateway: Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str root_password: The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster
        """
        pulumi.set(__self__, "activation_key", activation_key)
        pulumi.set(__self__, "admin_password", admin_password)
        pulumi.set(__self__, "controller1", controller1)
        pulumi.set(__self__, "controller_fqdn", controller_fqdn)
        pulumi.set(__self__, "hostname", hostname)
        pulumi.set(__self__, "license_id", license_id)
        pulumi.set(__self__, "license_key", license_key)
        pulumi.set(__self__, "panorama_auth_key", panorama_auth_key)
        pulumi.set(__self__, "panorama_ip_address", panorama_ip_address)
        pulumi.set(__self__, "private_address", private_address)
        pulumi.set(__self__, "private_cidr_mask", private_cidr_mask)
        pulumi.set(__self__, "private_gateway", private_gateway)
        pulumi.set(__self__, "root_password", root_password)

    @property
    @pulumi.getter(name="activationKey")
    def activation_key(self) -> str:
        """
        Activation key. This is required for Velocloud clusters
        """
        return pulumi.get(self, "activation_key")

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> str:
        """
        The administrative password of the device. You can use it to log in to the console. This field is not available for all device types
        """
        return pulumi.get(self, "admin_password")

    @property
    @pulumi.getter
    def controller1(self) -> str:
        """
        System IP Address. Mandatory for the Fortinet SDWAN cluster device
        """
        return pulumi.get(self, "controller1")

    @property
    @pulumi.getter(name="controllerFqdn")
    def controller_fqdn(self) -> str:
        """
        Controller fqdn. This is required for Velocloud clusters
        """
        return pulumi.get(self, "controller_fqdn")

    @property
    @pulumi.getter
    def hostname(self) -> str:
        """
        Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="licenseId")
    def license_id(self) -> str:
        """
        License id. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_id")

    @property
    @pulumi.getter(name="licenseKey")
    def license_key(self) -> str:
        """
        License key. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_key")

    @property
    @pulumi.getter(name="panoramaAuthKey")
    def panorama_auth_key(self) -> str:
        """
        Panorama Server Auth Key. This field is relevant only for Palo Alto Networks Firewall devices
        """
        return pulumi.get(self, "panorama_auth_key")

    @property
    @pulumi.getter(name="panoramaIpAddress")
    def panorama_ip_address(self) -> str:
        """
        Panorama Server IP Address. This field is relevant only for Palo Alto Networks Firewall devices
        """
        return pulumi.get(self, "panorama_ip_address")

    @property
    @pulumi.getter(name="privateAddress")
    def private_address(self) -> str:
        """
        Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_address")

    @property
    @pulumi.getter(name="privateCidrMask")
    def private_cidr_mask(self) -> str:
        """
        Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_cidr_mask")

    @property
    @pulumi.getter(name="privateGateway")
    def private_gateway(self) -> str:
        """
        Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_gateway")

    @property
    @pulumi.getter(name="rootPassword")
    def root_password(self) -> str:
        """
        The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster
        """
        return pulumi.get(self, "root_password")


@pulumi.output_type
class GetDeviceClusterDetailNode1Result(dict):
    def __init__(__self__, *,
                 license_file_id: str,
                 license_token: str,
                 name: str,
                 uuid: str,
                 vendor_configurations: Sequence['outputs.GetDeviceClusterDetailNode1VendorConfigurationResult']):
        """
        :param str license_file_id: Unique identifier of applied license file
        :param str license_token: License token. This is necessary for Palo Alto clusters
        :param str name: Name of an existing Equinix Network Edge device
        :param str uuid: UUID of an existing Equinix Network Edge device
        :param Sequence['GetDeviceClusterDetailNode1VendorConfigurationArgs'] vendor_configurations: An object that has fields relevant to the vendor of the cluster device
        """
        pulumi.set(__self__, "license_file_id", license_file_id)
        pulumi.set(__self__, "license_token", license_token)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "uuid", uuid)
        pulumi.set(__self__, "vendor_configurations", vendor_configurations)

    @property
    @pulumi.getter(name="licenseFileId")
    def license_file_id(self) -> str:
        """
        Unique identifier of applied license file
        """
        return pulumi.get(self, "license_file_id")

    @property
    @pulumi.getter(name="licenseToken")
    def license_token(self) -> str:
        """
        License token. This is necessary for Palo Alto clusters
        """
        return pulumi.get(self, "license_token")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def uuid(self) -> str:
        """
        UUID of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter(name="vendorConfigurations")
    def vendor_configurations(self) -> Sequence['outputs.GetDeviceClusterDetailNode1VendorConfigurationResult']:
        """
        An object that has fields relevant to the vendor of the cluster device
        """
        return pulumi.get(self, "vendor_configurations")


@pulumi.output_type
class GetDeviceClusterDetailNode1VendorConfigurationResult(dict):
    def __init__(__self__, *,
                 activation_key: str,
                 admin_password: str,
                 controller1: str,
                 controller_fqdn: str,
                 hostname: str,
                 license_id: str,
                 license_key: str,
                 panorama_auth_key: str,
                 panorama_ip_address: str,
                 private_address: str,
                 private_cidr_mask: str,
                 private_gateway: str,
                 root_password: str):
        """
        :param str activation_key: Activation key. This is required for Velocloud clusters
        :param str admin_password: The administrative password of the device. You can use it to log in to the console. This field is not available for all device types
        :param str controller1: System IP Address. Mandatory for the Fortinet SDWAN cluster device
        :param str controller_fqdn: Controller fqdn. This is required for Velocloud clusters
        :param str hostname: Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters
        :param str license_id: License id. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str license_key: License key. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str panorama_auth_key: Panorama Server Auth Key. This field is relevant only for Palo Alto Networks Firewall devices
        :param str panorama_ip_address: Panorama Server IP Address. This field is relevant only for Palo Alto Networks Firewall devices
        :param str private_address: Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_cidr_mask: Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str private_gateway: Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        :param str root_password: The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster
        """
        pulumi.set(__self__, "activation_key", activation_key)
        pulumi.set(__self__, "admin_password", admin_password)
        pulumi.set(__self__, "controller1", controller1)
        pulumi.set(__self__, "controller_fqdn", controller_fqdn)
        pulumi.set(__self__, "hostname", hostname)
        pulumi.set(__self__, "license_id", license_id)
        pulumi.set(__self__, "license_key", license_key)
        pulumi.set(__self__, "panorama_auth_key", panorama_auth_key)
        pulumi.set(__self__, "panorama_ip_address", panorama_ip_address)
        pulumi.set(__self__, "private_address", private_address)
        pulumi.set(__self__, "private_cidr_mask", private_cidr_mask)
        pulumi.set(__self__, "private_gateway", private_gateway)
        pulumi.set(__self__, "root_password", root_password)

    @property
    @pulumi.getter(name="activationKey")
    def activation_key(self) -> str:
        """
        Activation key. This is required for Velocloud clusters
        """
        return pulumi.get(self, "activation_key")

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> str:
        """
        The administrative password of the device. You can use it to log in to the console. This field is not available for all device types
        """
        return pulumi.get(self, "admin_password")

    @property
    @pulumi.getter
    def controller1(self) -> str:
        """
        System IP Address. Mandatory for the Fortinet SDWAN cluster device
        """
        return pulumi.get(self, "controller1")

    @property
    @pulumi.getter(name="controllerFqdn")
    def controller_fqdn(self) -> str:
        """
        Controller fqdn. This is required for Velocloud clusters
        """
        return pulumi.get(self, "controller_fqdn")

    @property
    @pulumi.getter
    def hostname(self) -> str:
        """
        Hostname. This is necessary for Palo Alto, Juniper, and Fortinet clusters
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="licenseId")
    def license_id(self) -> str:
        """
        License id. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_id")

    @property
    @pulumi.getter(name="licenseKey")
    def license_key(self) -> str:
        """
        License key. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "license_key")

    @property
    @pulumi.getter(name="panoramaAuthKey")
    def panorama_auth_key(self) -> str:
        """
        Panorama Server Auth Key. This field is relevant only for Palo Alto Networks Firewall devices
        """
        return pulumi.get(self, "panorama_auth_key")

    @property
    @pulumi.getter(name="panoramaIpAddress")
    def panorama_ip_address(self) -> str:
        """
        Panorama Server IP Address. This field is relevant only for Palo Alto Networks Firewall devices
        """
        return pulumi.get(self, "panorama_ip_address")

    @property
    @pulumi.getter(name="privateAddress")
    def private_address(self) -> str:
        """
        Private address. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_address")

    @property
    @pulumi.getter(name="privateCidrMask")
    def private_cidr_mask(self) -> str:
        """
        Private CIDR Mask. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_cidr_mask")

    @property
    @pulumi.getter(name="privateGateway")
    def private_gateway(self) -> str:
        """
        Private gateway. This field is relevant only for the BlueCat DNS and DHCP Server
        """
        return pulumi.get(self, "private_gateway")

    @property
    @pulumi.getter(name="rootPassword")
    def root_password(self) -> str:
        """
        The CLI password of the device. This field is relevant only for the Velocloud SDWAN cluster
        """
        return pulumi.get(self, "root_password")


@pulumi.output_type
class GetDeviceInterfaceResult(dict):
    def __init__(__self__, *,
                 assigned_type: str,
                 id: int,
                 ip_address: str,
                 mac_address: str,
                 name: str,
                 operational_status: str,
                 status: str,
                 type: str):
        """
        :param str assigned_type: Interface management type (Equinix Managed or empty)
        :param int id: Interface identifier
        :param str ip_address: interface IP address
        :param str mac_address: Interface MAC addres
        :param str name: Name of an existing Equinix Network Edge device
        :param str operational_status: Interface operational status (up or down)
        :param str status: Device provisioning status
               * INITIALIZING
               * PROVISIONING
               * PROVISIONED (**NOTE: By default data source will only return devices in this state. To include other states see `valid_state_list`**)
               * WAITING_FOR_PRIMARY
               * WAITING_FOR_SECONDARY
               * WAITING_FOR_REPLICA_CLUSTER_NODES
               * CLUSTER_SETUP_IN_PROGRESS
               * FAILED
               * DEPROVISIONING
               * DEPROVISIONED
               * RESOURCE_UPGRADE_IN_PROGRESS
               * RESOURCE_UPGRADE_FAILED
        :param str type: Interface type
        """
        pulumi.set(__self__, "assigned_type", assigned_type)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "ip_address", ip_address)
        pulumi.set(__self__, "mac_address", mac_address)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "operational_status", operational_status)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="assignedType")
    def assigned_type(self) -> str:
        """
        Interface management type (Equinix Managed or empty)
        """
        return pulumi.get(self, "assigned_type")

    @property
    @pulumi.getter
    def id(self) -> int:
        """
        Interface identifier
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> str:
        """
        interface IP address
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter(name="macAddress")
    def mac_address(self) -> str:
        """
        Interface MAC addres
        """
        return pulumi.get(self, "mac_address")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="operationalStatus")
    def operational_status(self) -> str:
        """
        Interface operational status (up or down)
        """
        return pulumi.get(self, "operational_status")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Device provisioning status
        * INITIALIZING
        * PROVISIONING
        * PROVISIONED (**NOTE: By default data source will only return devices in this state. To include other states see `valid_state_list`**)
        * WAITING_FOR_PRIMARY
        * WAITING_FOR_SECONDARY
        * WAITING_FOR_REPLICA_CLUSTER_NODES
        * CLUSTER_SETUP_IN_PROGRESS
        * FAILED
        * DEPROVISIONING
        * DEPROVISIONED
        * RESOURCE_UPGRADE_IN_PROGRESS
        * RESOURCE_UPGRADE_FAILED
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Interface type
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetDeviceSecondaryDeviceResult(dict):
    def __init__(__self__, *,
                 account_number: str,
                 acl_template_id: str,
                 additional_bandwidth: int,
                 asn: int,
                 cloud_init_file_id: str,
                 hostname: str,
                 ibx: str,
                 interfaces: Sequence['outputs.GetDeviceSecondaryDeviceInterfaceResult'],
                 license_file: str,
                 license_file_id: str,
                 license_status: str,
                 license_token: str,
                 metro_code: str,
                 mgmt_acl_template_uuid: str,
                 name: str,
                 notifications: Sequence[str],
                 project_id: str,
                 redundancy_type: str,
                 redundant_id: str,
                 region: str,
                 ssh_ip_address: str,
                 ssh_ip_fqdn: str,
                 ssh_keys: Sequence['outputs.GetDeviceSecondaryDeviceSshKeyResult'],
                 status: str,
                 uuid: str,
                 vendor_configuration: Mapping[str, str],
                 wan_interface_id: str,
                 zone_code: str):
        """
        :param str account_number: Device billing account number
        :param str acl_template_id: Unique identifier of applied ACL template
        :param int additional_bandwidth: Additional Internet bandwidth, in Mbps, that will be allocated to the device
        :param int asn: Autonomous system number
        :param str cloud_init_file_id: Unique identifier of applied cloud init file
        :param str hostname: Device hostname prefix
        :param str ibx: Device location Equinix Business Exchange name
        :param Sequence['GetDeviceSecondaryDeviceInterfaceArgs'] interfaces: List of device interfaces
               * `interface.#.id` - interface identifier
               * `interface.#.name` - interface name
               * `interface.#.status` - interface status (AVAILABLE, RESERVED, ASSIGNED)
               * `interface.#.operational_status` - interface operational status (up or down)
               * `interface.#.mac_address` - interface MAC address
               * `interface.#.ip_address` - interface IP address
               * `interface.#.assigned_type` - interface management type (Equinix Managed or empty)
               * `interface.#.type` - interface type
        :param str license_file: Path to the license file that will be uploaded and applied on a device, applicable for some device types in BYOL licensing mode
        :param str license_file_id: Unique identifier of applied license file
        :param str license_status: Device license registration status
               * APPLYING_LICENSE
               * REGISTERED
               * APPLIED
               * WAITING_FOR_CLUSTER_SETUP
               * REGISTRATION_FAILED
               * NA
        :param str license_token: License Token applicable for some device types in BYOL licensing mode
        :param str metro_code: Device location metro code
        :param str mgmt_acl_template_uuid: Unique identifier of applied MGMT ACL template
        :param str name: Name of an existing Equinix Network Edge device
        :param Sequence[str] notifications: List of email addresses that will receive device status notifications
        :param str project_id: The unique identifier of Project Resource to which device is scoped to
        :param str redundancy_type: Device redundancy type applicable for HA devices, either primary or secondary
        :param str redundant_id: Unique identifier for a redundant device applicable for HA devices
        :param str region: Device location region
        :param str ssh_ip_address: IP address of SSH enabled interface on the device
        :param str ssh_ip_fqdn: FQDN of SSH enabled interface on the device
        :param Sequence['GetDeviceSecondaryDeviceSshKeyArgs'] ssh_keys: Definition of SSH key that will be provisioned on a device
        :param str status: Device provisioning status
               * INITIALIZING
               * PROVISIONING
               * PROVISIONED (**NOTE: By default data source will only return devices in this state. To include other states see `valid_state_list`**)
               * WAITING_FOR_PRIMARY
               * WAITING_FOR_SECONDARY
               * WAITING_FOR_REPLICA_CLUSTER_NODES
               * CLUSTER_SETUP_IN_PROGRESS
               * FAILED
               * DEPROVISIONING
               * DEPROVISIONED
               * RESOURCE_UPGRADE_IN_PROGRESS
               * RESOURCE_UPGRADE_FAILED
        :param str uuid: UUID of an existing Equinix Network Edge device
        :param Mapping[str, str] vendor_configuration: Map of vendor specific configuration parameters for a device (controller1, activationKey, managementType, siteId, systemIpAddress)
        :param str wan_interface_id: device interface id picked for WAN
        :param str zone_code: Device location zone code
        """
        pulumi.set(__self__, "account_number", account_number)
        pulumi.set(__self__, "acl_template_id", acl_template_id)
        pulumi.set(__self__, "additional_bandwidth", additional_bandwidth)
        pulumi.set(__self__, "asn", asn)
        pulumi.set(__self__, "cloud_init_file_id", cloud_init_file_id)
        pulumi.set(__self__, "hostname", hostname)
        pulumi.set(__self__, "ibx", ibx)
        pulumi.set(__self__, "interfaces", interfaces)
        pulumi.set(__self__, "license_file", license_file)
        pulumi.set(__self__, "license_file_id", license_file_id)
        pulumi.set(__self__, "license_status", license_status)
        pulumi.set(__self__, "license_token", license_token)
        pulumi.set(__self__, "metro_code", metro_code)
        pulumi.set(__self__, "mgmt_acl_template_uuid", mgmt_acl_template_uuid)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "notifications", notifications)
        pulumi.set(__self__, "project_id", project_id)
        pulumi.set(__self__, "redundancy_type", redundancy_type)
        pulumi.set(__self__, "redundant_id", redundant_id)
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "ssh_ip_address", ssh_ip_address)
        pulumi.set(__self__, "ssh_ip_fqdn", ssh_ip_fqdn)
        pulumi.set(__self__, "ssh_keys", ssh_keys)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "uuid", uuid)
        pulumi.set(__self__, "vendor_configuration", vendor_configuration)
        pulumi.set(__self__, "wan_interface_id", wan_interface_id)
        pulumi.set(__self__, "zone_code", zone_code)

    @property
    @pulumi.getter(name="accountNumber")
    def account_number(self) -> str:
        """
        Device billing account number
        """
        return pulumi.get(self, "account_number")

    @property
    @pulumi.getter(name="aclTemplateId")
    def acl_template_id(self) -> str:
        """
        Unique identifier of applied ACL template
        """
        return pulumi.get(self, "acl_template_id")

    @property
    @pulumi.getter(name="additionalBandwidth")
    def additional_bandwidth(self) -> int:
        """
        Additional Internet bandwidth, in Mbps, that will be allocated to the device
        """
        return pulumi.get(self, "additional_bandwidth")

    @property
    @pulumi.getter
    def asn(self) -> int:
        """
        Autonomous system number
        """
        return pulumi.get(self, "asn")

    @property
    @pulumi.getter(name="cloudInitFileId")
    def cloud_init_file_id(self) -> str:
        """
        Unique identifier of applied cloud init file
        """
        return pulumi.get(self, "cloud_init_file_id")

    @property
    @pulumi.getter
    def hostname(self) -> str:
        """
        Device hostname prefix
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter
    def ibx(self) -> str:
        """
        Device location Equinix Business Exchange name
        """
        return pulumi.get(self, "ibx")

    @property
    @pulumi.getter
    def interfaces(self) -> Sequence['outputs.GetDeviceSecondaryDeviceInterfaceResult']:
        """
        List of device interfaces
        * `interface.#.id` - interface identifier
        * `interface.#.name` - interface name
        * `interface.#.status` - interface status (AVAILABLE, RESERVED, ASSIGNED)
        * `interface.#.operational_status` - interface operational status (up or down)
        * `interface.#.mac_address` - interface MAC address
        * `interface.#.ip_address` - interface IP address
        * `interface.#.assigned_type` - interface management type (Equinix Managed or empty)
        * `interface.#.type` - interface type
        """
        return pulumi.get(self, "interfaces")

    @property
    @pulumi.getter(name="licenseFile")
    def license_file(self) -> str:
        """
        Path to the license file that will be uploaded and applied on a device, applicable for some device types in BYOL licensing mode
        """
        return pulumi.get(self, "license_file")

    @property
    @pulumi.getter(name="licenseFileId")
    def license_file_id(self) -> str:
        """
        Unique identifier of applied license file
        """
        return pulumi.get(self, "license_file_id")

    @property
    @pulumi.getter(name="licenseStatus")
    def license_status(self) -> str:
        """
        Device license registration status
        * APPLYING_LICENSE
        * REGISTERED
        * APPLIED
        * WAITING_FOR_CLUSTER_SETUP
        * REGISTRATION_FAILED
        * NA
        """
        return pulumi.get(self, "license_status")

    @property
    @pulumi.getter(name="licenseToken")
    def license_token(self) -> str:
        """
        License Token applicable for some device types in BYOL licensing mode
        """
        return pulumi.get(self, "license_token")

    @property
    @pulumi.getter(name="metroCode")
    def metro_code(self) -> str:
        """
        Device location metro code
        """
        return pulumi.get(self, "metro_code")

    @property
    @pulumi.getter(name="mgmtAclTemplateUuid")
    def mgmt_acl_template_uuid(self) -> str:
        """
        Unique identifier of applied MGMT ACL template
        """
        return pulumi.get(self, "mgmt_acl_template_uuid")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def notifications(self) -> Sequence[str]:
        """
        List of email addresses that will receive device status notifications
        """
        return pulumi.get(self, "notifications")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> str:
        """
        The unique identifier of Project Resource to which device is scoped to
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="redundancyType")
    def redundancy_type(self) -> str:
        """
        Device redundancy type applicable for HA devices, either primary or secondary
        """
        return pulumi.get(self, "redundancy_type")

    @property
    @pulumi.getter(name="redundantId")
    def redundant_id(self) -> str:
        """
        Unique identifier for a redundant device applicable for HA devices
        """
        return pulumi.get(self, "redundant_id")

    @property
    @pulumi.getter
    def region(self) -> str:
        """
        Device location region
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="sshIpAddress")
    def ssh_ip_address(self) -> str:
        """
        IP address of SSH enabled interface on the device
        """
        return pulumi.get(self, "ssh_ip_address")

    @property
    @pulumi.getter(name="sshIpFqdn")
    def ssh_ip_fqdn(self) -> str:
        """
        FQDN of SSH enabled interface on the device
        """
        return pulumi.get(self, "ssh_ip_fqdn")

    @property
    @pulumi.getter(name="sshKeys")
    def ssh_keys(self) -> Sequence['outputs.GetDeviceSecondaryDeviceSshKeyResult']:
        """
        Definition of SSH key that will be provisioned on a device
        """
        return pulumi.get(self, "ssh_keys")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Device provisioning status
        * INITIALIZING
        * PROVISIONING
        * PROVISIONED (**NOTE: By default data source will only return devices in this state. To include other states see `valid_state_list`**)
        * WAITING_FOR_PRIMARY
        * WAITING_FOR_SECONDARY
        * WAITING_FOR_REPLICA_CLUSTER_NODES
        * CLUSTER_SETUP_IN_PROGRESS
        * FAILED
        * DEPROVISIONING
        * DEPROVISIONED
        * RESOURCE_UPGRADE_IN_PROGRESS
        * RESOURCE_UPGRADE_FAILED
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def uuid(self) -> str:
        """
        UUID of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "uuid")

    @property
    @pulumi.getter(name="vendorConfiguration")
    def vendor_configuration(self) -> Mapping[str, str]:
        """
        Map of vendor specific configuration parameters for a device (controller1, activationKey, managementType, siteId, systemIpAddress)
        """
        return pulumi.get(self, "vendor_configuration")

    @property
    @pulumi.getter(name="wanInterfaceId")
    def wan_interface_id(self) -> str:
        """
        device interface id picked for WAN
        """
        return pulumi.get(self, "wan_interface_id")

    @property
    @pulumi.getter(name="zoneCode")
    def zone_code(self) -> str:
        """
        Device location zone code
        """
        return pulumi.get(self, "zone_code")


@pulumi.output_type
class GetDeviceSecondaryDeviceInterfaceResult(dict):
    def __init__(__self__, *,
                 assigned_type: str,
                 id: int,
                 ip_address: str,
                 mac_address: str,
                 name: str,
                 operational_status: str,
                 status: str,
                 type: str):
        """
        :param str assigned_type: Interface management type (Equinix Managed or empty)
        :param int id: Interface identifier
        :param str ip_address: interface IP address
        :param str mac_address: Interface MAC addres
        :param str name: Name of an existing Equinix Network Edge device
        :param str operational_status: Interface operational status (up or down)
        :param str status: Device provisioning status
               * INITIALIZING
               * PROVISIONING
               * PROVISIONED (**NOTE: By default data source will only return devices in this state. To include other states see `valid_state_list`**)
               * WAITING_FOR_PRIMARY
               * WAITING_FOR_SECONDARY
               * WAITING_FOR_REPLICA_CLUSTER_NODES
               * CLUSTER_SETUP_IN_PROGRESS
               * FAILED
               * DEPROVISIONING
               * DEPROVISIONED
               * RESOURCE_UPGRADE_IN_PROGRESS
               * RESOURCE_UPGRADE_FAILED
        :param str type: Interface type
        """
        pulumi.set(__self__, "assigned_type", assigned_type)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "ip_address", ip_address)
        pulumi.set(__self__, "mac_address", mac_address)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "operational_status", operational_status)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="assignedType")
    def assigned_type(self) -> str:
        """
        Interface management type (Equinix Managed or empty)
        """
        return pulumi.get(self, "assigned_type")

    @property
    @pulumi.getter
    def id(self) -> int:
        """
        Interface identifier
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> str:
        """
        interface IP address
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter(name="macAddress")
    def mac_address(self) -> str:
        """
        Interface MAC addres
        """
        return pulumi.get(self, "mac_address")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of an existing Equinix Network Edge device
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="operationalStatus")
    def operational_status(self) -> str:
        """
        Interface operational status (up or down)
        """
        return pulumi.get(self, "operational_status")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Device provisioning status
        * INITIALIZING
        * PROVISIONING
        * PROVISIONED (**NOTE: By default data source will only return devices in this state. To include other states see `valid_state_list`**)
        * WAITING_FOR_PRIMARY
        * WAITING_FOR_SECONDARY
        * WAITING_FOR_REPLICA_CLUSTER_NODES
        * CLUSTER_SETUP_IN_PROGRESS
        * FAILED
        * DEPROVISIONING
        * DEPROVISIONED
        * RESOURCE_UPGRADE_IN_PROGRESS
        * RESOURCE_UPGRADE_FAILED
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Interface type
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetDeviceSecondaryDeviceSshKeyResult(dict):
    def __init__(__self__, *,
                 key_name: str,
                 username: str):
        """
        :param str key_name: Reference by name to previously provisioned public SSH key
        :param str username: Username associated with given key
        """
        pulumi.set(__self__, "key_name", key_name)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="keyName")
    def key_name(self) -> str:
        """
        Reference by name to previously provisioned public SSH key
        """
        return pulumi.get(self, "key_name")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        Username associated with given key
        """
        return pulumi.get(self, "username")


@pulumi.output_type
class GetDeviceSshKeyResult(dict):
    def __init__(__self__, *,
                 key_name: str,
                 username: str):
        """
        :param str key_name: Reference by name to previously provisioned public SSH key
        :param str username: Username associated with given key
        """
        pulumi.set(__self__, "key_name", key_name)
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="keyName")
    def key_name(self) -> str:
        """
        Reference by name to previously provisioned public SSH key
        """
        return pulumi.get(self, "key_name")

    @property
    @pulumi.getter
    def username(self) -> str:
        """
        Username associated with given key
        """
        return pulumi.get(self, "username")


